resources:
  limits:
    cpu: 50m
    memory: 200Mi
  requests:
    cpu: 20m
    memory: 100Mi
rbac:
  create: true
  pspEnabled: false
config:
  datasource:
    host: psql-dp2-golem.postgres.database.azure.com
    user: prometheus
    passwordSecret:
      name: monitoring-secret
      key: postgres-exporter-ds-password
    port: "6432"
    database: postgres
    sslmode: verify-full
  disableCollectorBgwriter: true
  disableDefaultMetrics: true
  disableSettingsMetrics: true
  autoDiscoverDatabases: true
  logLevel: warn
  #excludeDatabases: ["postgres", "template0", "template1"]
  includeDatabases: ["dataplatform", "pragozor", "sandbox", "stage"]
  queries: |
    pg_table_index_invalid:
      query: |
        SELECT current_database() as database, count(*) FROM pg_index 
          LEFT JOIN pg_class ON pg_class.oid = pg_index.indrelid
          WHERE pg_index.indisvalid = false;
      metrics:
        - database:
            usage: "LABEL"
            description: "Name of this database"
        - count:
            usage: "GAUGE"
            description: "Number of invalid indexes"

#    pg_stat_user_tables:
#      query: |
#       SELECT
#         current_database() datname,
#         schemaname,
#         relname,
#         seq_scan,
#         seq_tup_read,
#         n_live_tup,
#         n_dead_tup,
#         n_mod_since_analyze,
#         COALESCE(last_vacuum, '1970-01-01Z') as last_vacuum,
#         COALESCE(last_autovacuum, '1970-01-01Z') as last_autovacuum,
#         COALESCE(last_analyze, '1970-01-01Z') as last_analyze,
#         COALESCE(last_autoanalyze, '1970-01-01Z') as last_autoanalyze,
#         vacuum_count,
#         autovacuum_count,
#         analyze_count,
#         autoanalyze_count
#       FROM
#         pg_stat_user_tables
#      metrics:
#        - datname:
#            usage: "LABEL"
#            description: "Name of current database"
#        - schemaname:
#            usage: "LABEL"
#            description: "Name of the schema that this table is in"
#        - relname:
#            usage: "LABEL"
#            description: "Name of this table"
#        - seq_scan:
#            usage: "COUNTER"
#            description: "Number of sequential scans initiated on this table"
#        - seq_tup_read:
#            usage: "COUNTER"
#            description: "Number of live rows fetched by sequential scans"
#        - n_live_tup:
#            usage: "GAUGE"
#            description: "Estimated number of live rows"
#        - n_dead_tup:
#            usage: "GAUGE"
#            description: "Estimated number of dead rows"
#        - n_mod_since_analyze:
#            usage: "GAUGE"
#            description: "Estimated number of rows changed since last analyze"
#        - last_vacuum:
#            usage: "GAUGE"
#            description: "Last time at which this table was manually vacuumed (not counting VACUUM FULL)"
#        - last_autovacuum:
#            usage: "GAUGE"
#            description: "Last time at which this table was vacuumed by the autovacuum daemon"
#        - last_analyze:
#            usage: "GAUGE"
#            description: "Last time at which this table was manually analyzed"
#        - last_autoanalyze:
#            usage: "GAUGE"
#            description: "Last time at which this table was analyzed by the autovacuum daemon"
#        - vacuum_count:
#            usage: "COUNTER"
#            description: "Number of times this table has been manually vacuumed (not counting VACUUM FULL)"
#        - autovacuum_count:
#            usage: "COUNTER"
#            description: "Number of times this table has been vacuumed by the autovacuum daemon"
#        - analyze_count:
#            usage: "COUNTER"
#            description: "Number of times this table has been manually analyzed"
#        - autoanalyze_count:
#            usage: "COUNTER"
#            description: "Number of times this table has been analyzed by the autovacuum daemon"
#
#    pg_stat_statements:
#      query: "SELECT t2.rolname, t3.datname, queryid, calls, total_exec_time / 1000 as total_time_seconds, min_exec_time / 1000 as min_time_seconds, max_exec_time / 1000 as max_time_seconds, mean_exec_time / 1000 as mean_time_seconds, stddev_exec_time / 1000 as stddev_time_seconds, rows FROM pg_stat_statements t1 JOIN pg_roles t2 ON (t1.userid=t2.oid) JOIN pg_database t3 ON (t1.dbid=t3.oid) WHERE t2.rolname != 'rdsadmin'"
#      master: true
#      metrics:
#        - rolname:
#            usage: "LABEL"
#            description: "Name of user"
#        - datname:
#            usage: "LABEL"
#            description: "Name of database"
#        - queryid:
#            usage: "LABEL"
#            description: "Query ID"
#        - calls:
#            usage: "COUNTER"
#            description: "Number of times executed"
#        - total_time_seconds:
#            usage: "COUNTER"
#            description: "Total time spent in the statement, in milliseconds"
#        - min_time_seconds:
#            usage: "GAUGE"
#            description: "Minimum time spent in the statement, in milliseconds"
#        - max_time_seconds:
#            usage: "GAUGE"
#            description: "Maximum time spent in the statement, in milliseconds"
#        - mean_time_seconds:
#            usage: "GAUGE"
#            description: "Mean time spent in the statement, in milliseconds"
#        - stddev_time_seconds:
#            usage: "GAUGE"
#            description: "Population standard deviation of time spent in the statement, in milliseconds"
#        - rows:
#            usage: "COUNTER"
#            description: "Total number of rows retrieved or affected by the statement"
#
#    pg_stat_table_size:
#      query: |
#        WITH
#        RECURSIVE pg_inherit(inhrelid, inhparent) AS (
#            select inhrelid, inhparent
#            FROM pg_inherits
#            UNION
#            SELECT child.inhrelid, parent.inhparent
#            FROM pg_inherit child, pg_inherits parent
#            WHERE child.inhparent = parent.inhrelid),
#        pg_inherit_short AS (SELECT * FROM pg_inherit WHERE inhparent NOT IN (SELECT inhrelid FROM pg_inherit))
#        SELECT
#        current_database() datname,
#        table_schema
#            , table_name
#            , row_estimate
#            , total_bytes
#            FROM (
#            SELECT *, total_bytes-index_bytes-COALESCE(toast_bytes,0) AS table_bytes
#            FROM (
#                SELECT c.oid
#                    , nspname AS table_schema
#                    , relname AS table_name
#                    , SUM(c.reltuples) OVER (partition BY parent) AS row_estimate
#                    , SUM(pg_total_relation_size(c.oid)) OVER (partition BY parent) AS total_bytes
#                    , SUM(pg_indexes_size(c.oid)) OVER (partition BY parent) AS index_bytes
#                    , SUM(pg_total_relation_size(reltoastrelid)) OVER (partition BY parent) AS toast_bytes
#                    , parent
#                FROM (
#                    SELECT pg_class.oid
#                        , reltuples
#                        , relname
#                        , relnamespace
#                        , pg_class.reltoastrelid
#                        , COALESCE(inhparent, pg_class.oid) parent
#                    FROM pg_class
#                        LEFT JOIN pg_inherit_short ON inhrelid = oid
#                    WHERE relkind IN ('r', 'p')
#                    ) c
#                LEFT JOIN pg_namespace n ON n.oid = c.relnamespace
#            ) a
#            WHERE oid = parent
#        ) a
#        ORDER BY total_bytes desc
#        limit 20
#      master: false
#      cache_seconds: 3600
#      metrics:
#        - datname:
#            usage: "LABEL"
#            description: "Name of database"
#        - table_schema:
#            usage: "LABEL"
#            description: "Name of schema"
#        - table_name:
#            usage: "LABEL"
#            description: "Name of table"
#        - row_estimate:
#            usage: "GAUGE"
#            description: "Count of rows"
#        - total_bytes:
#            usage: "GAUGE"
#            description: "Total table space"
